hdu 1546 Idiomatic Phrases Game 最短路

Idiomatic Phrases Game

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)

Total Submission(s): 2283    Accepted Submission(s): 742

Problem Description

Tom is playing a game called Idiomatic Phrases Game. An idiom consists of several Chinese characters and has a certain meaning. This game will give Tom two idioms. He should build a list of idioms and the list starts and ends with
the two given idioms. For every two adjacent idioms, the last Chinese character of the former idiom should be the same as the first character of the latter one. For each time, Tom has a dictionary that he must pick idioms from and each idiom in the dictionary
has a value indicates how long Tom will take to find the next proper idiom in the final list. Now you are asked to write a program to compute the shortest time Tom will take by giving you the idiom dictionary.

Input

The input consists of several test cases. Each test case contains an idiom dictionary. The dictionary is started by an integer N (0 < N < 1000) in one line. The following is N lines. Each line contains an integer T (the time Tom will
take to work out) and an idiom. One idiom consists of several Chinese characters (at least 3) and one Chinese character consists of four hex digit (i.e., 0 to 9 and A to F). Note that the first and last idioms in the dictionary are the source and target idioms
in the game. The input ends up with a case that N = 0. Do not process this case.

Output

One line for each case. Output an integer indicating the shortest time Tome will take. If the list can not be built, please output -1.

Sample Input

5
5 12345978ABCD2341
5 23415608ACBD3412
7 34125678AEFD4123
15 23415673ACC34123
4 41235673FBCD2156
2
20 12345678ABCD
30 DCBF5432167D
0

Sample Output

17
-1

其实弄懂这道题后,就会发现。。水题一枚。

给出n个“成语”, 这写成语至少由3个“汉字”组成,所谓的“汉字”,是指4个连续的16进制数字(1~9, A~F)。

以第一个成语作为起点,最后一个作为终点, 需要找出一个序列,这个序列的前一个成语的最后一个“汉字”与后一个成语的第一个“汉字”是相同的,求最少花费时间。

代码:

#include <stdio.h>
#include <string.h>
#define INF 1000000000
struct Node{
	char s[5],e[5] ;
	int t ;
}list[1100];
int graph[1100][1100] , dis[1100];

void dijkstra(int n)
{
	bool visited[1100] ;
	for(int i = 0 ; i < n ; ++i)
	{
		dis[i] = graph[0][i] ;
		visited[i] = false ;
	}
	dis[0] = 0 ;
	visited[0] = true ;
	for(int i = 1 ; i < n ; ++i)
	{
		int min = INF , index = -1 ;
		for(int j = 0 ; j < n ; ++j)
		{
			if(!visited[j] && min>dis[j])
			{
				index = j ;
				min = dis[j] ;
			}
		}
		if(index == -1)
		{
			return ;
		}
		visited[index] = true ;
		for(int j = 0 ; j < n ; ++j)
		{
			if(!visited[j] && dis[j]>min+graph[index][j])
			{
				dis[j] = min+graph[index][j] ;
			}
		}
	}
}

int main()
{
	int n ;
	while(scanf("%d",&n) && n)
	{
		for(int i = 0 ; i < n ; ++i)
		{
			for(int j = 0 ; j < n ; ++j)
			{
				graph[i][j] = INF ;
			}
		}
		char str[110] ;
		for(int i = 0 ; i < n ; ++i)
		{
			scanf("%d%s",&list[i].t,str) ;
			for(int j = 0 ; j < 4 ; ++j)
			{
				list[i].s[j] = str[j] ;
			}
			list[i].s[4] = '\0' ;
			int k = 0 ;
			for(int j = strlen(str)-4 ; j < strlen(str) ; ++j)
			{
				list[i].e[k++] = str[j] ;
			}
			list[i].e[4] = '\0' ;
		}
		for(int i = 0 ; i < n-1 ; ++i)
		{
			for(int j = 0 ; j < n ; ++j)
			{
				if(strcmp(list[i].e,list[j].s)==0)
				{
					graph[i][j] = list[i].t ;
				}
			}
		}
		dijkstra(n) ;
		if(dis[n-1] == INF)
			puts("-1") ;
		else
			printf("%d\n",dis[n-1]) ;
	}
	return 0 ;
}

与君共勉

时间: 2024-08-23 23:32:21

hdu 1546 Idiomatic Phrases Game 最短路的相关文章

HDU 1546 Idiomatic Phrases Game

成语接龙. 上一个的尾必须和下一个的首相同.注意:花费的时间是上一个. 一开始我就建图建错了. 比如第 i 个成语 与第 j 个成语, 第  i 个成语前面的时间为 t : 建图为 i -> j = t: 基友说这<图论算法理论.实现及应用>上有一样的题,我借来看了一下,发现它建图似乎有错误. 0->3 这条边的权值似乎错了. 反正我的建图是这样的 0->1=5;0->3=5; 1->2=5; 2->4=7; 3->4=15; 求 0 -> 4

HDU 1546 Idiomatic Phrases Game(dijkstra+优先队列)

Idiomatic Phrases Game Problem Description Tom is playing a game called Idiomatic Phrases Game. An idiom consists of several Chinese characters and has a certain meaning. This game will give Tom two idioms. He should build a list of idioms and the li

ZOJ-2750 Idiomatic Phrases Game---Dijk最短路

题目链接: https://vjudge.net/problem/ZOJ-2750 题目大意: 给定一本字典,字典里有很多成语,要求从字典里的第一个成语开始,运用字典里的成语变到最后一个成语,变得过程就是成语接龙,后一个成语的第一个字必须有前一个成语的最后一个字相等,给定的成语是4位16进制数字,每个成语前边跟的数字代表着找到这个成语之后再找到下个成语还需要t分钟 .(这里是找到该成语后还需要时间t,才能找到下一个成语) 思路: 每个成语有前面四个字符和后面四个字符,如果第i个成语后面字符等于第

Idiomatic Phrases Game HDU 1546

Description Tom is playing a game called Idiomatic Phrases Game. An idiom consists of several Chinese characters and has a certain meaning. This game will give Tom two idioms. He should build a list of idioms and the list starts and ends with the two

Idiomatic Phrases Game(图论最短路)

Idiomatic Phrases Game Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 3504    Accepted Submission(s): 1182 Problem Description Tom is playing a game called Idiomatic Phrases Game. An idiom cons

ZOJ2750_Idiomatic Phrases Game(最短路)

Idiomatic Phrases Game Time Limit: 2 Seconds      Memory Limit: 65536 KB Tom is playing a game called Idiomatic Phrases Game. An idiom consists of several Chinese characters and has a certain meaning. This game will give Tom two idioms. He should bui

zoj 1750 Idiomatic Phrases Game (dijkstra)

Idiomatic Phrases Game Time Limit: 2 Seconds      Memory Limit: 65536 KB Tom is playing a game called Idiomatic Phrases Game. An idiom consists of several Chinese characters and has a certain meaning. This game will give Tom two idioms. He should bui

ZOJ 2750 -- Idiomatic Phrases Game(Dijkstra)

 ZOJ 2750 -- Idiomatic Phrases Game(Dijkstra) 题意 : 给定一本字典,字典里有很多成语,要求从字典里的第一个成语开始,运用字典里的成语变到最后一个成语,变得过程就是成语接龙,后一个成语的第一个字必须有前一个成语的最后一个字相等,给定的成语是4位16进制位,每个成语前边跟的数字代表着找到这个成语之后再找到下个成语还需要t分钟 . 思路 : 将所有的成语看成一个点,如果找到下一个成语,就建一条有向边,然后用dijkstra求最短路. 1 #include

HDU 4034 Graph(floyd,最短路,简单)

题目 一道简单的倒着的floyd. 具体可看代码,代码可简化,你有兴趣可以简化一下,就是把那个Dijsktra所实现的功能放到倒着的floyd里面去. #include<stdio.h> #include<string.h> #include<algorithm> using namespace std; const int MAXN=110; const int INF=0x3f3f3f3f;//防止后面溢出,这个不能太大 bool vis[MAXN]; int pr